SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!
SystemOrganization addCategory: #'IRDA2013-sorting2'!

Morph subclass: #AnimatedProtoMorph
	instanceVariableNames: 'animation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!AnimatedProtoMorph class methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 15:52:11.594'!
example1

	| morph |
	morph := Morph new
		position: 50@50;
		extent: 100@100.
	morph addMorph: (Morph new
		position: 60@60;
		extent: 80@80;
		color: Color yellow).
	
	(AnimPropertyAnimation on: morph property: #position start: (50@50) end: (400@400) duration: 10000)
		register;
		start: #deleteWhenFinished.
		
	morph openInWorld.! !

Morph subclass: #S2ItemListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

Morph subclass: #S2ItemMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemMorph methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 16:13:04.041'!
initialize 
	"init"
	super initialize.
	self on: #startDrag send: #startDrag:with: to: self.! !

Morph subclass: #S2ItemSpaceMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemSpaceMorph methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 16:23:53.262'!
initialize 
	"init"
	super initialize.
	self enableDrop:true.! !

Object subclass: #S2Item
	instanceVariableNames: 'value morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2Item class methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 17:51:08.784'!
newWithValue: value

	^ self new value: value.! !

!S2Item methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:50:23.528'!
morph

	morph ifNil: [ morph:= S2ItemMorph new ].
	^ morph! !

!S2Item methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:38:50.608'!
morph: anObject

	morph := anObject! !

!S2Item methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:49:49.384'!
value

	^ value! !

!S2Item methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:49:21.923'!
value: anObject

	value := anObject! !

Object subclass: #S2ItemList
	instanceVariableNames: 'items morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemList class methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 16:33:06.77'!
newWithItems: anArray
	^ self new addItems: anArray.! !

!S2ItemList methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 17:34:43.861'!
addItem: value

	self items add: (S2Item newWithValue: value).
	^ self.! !

!S2ItemList methodsFor: 'as yet unclassified' stamp: 'JB 5/13/2013 17:18:43.863'!
addItems: anArray

	anArray do: [ :item | self addItem: item. ]! !

!S2ItemList methodsFor: 'initialize-release' stamp: 'JB 5/13/2013 17:19:04.273'!
initialize
	
	super initialize.! !

!S2ItemList methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:18:35.802'!
items

	items ifNil: [items := OrderedCollection new].
	^ items! !

!S2ItemList methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:12:09.699'!
items: anObject

	items := anObject! !

!S2ItemList methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:23:09.016'!
morph

	morph ifNil: [morph := S2ItemListMorph new].
	^ morph! !

!S2ItemList methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:18:26.01'!
morph: anObject

	morph := anObject! !

Object subclass: #S2ItemSpace
	instanceVariableNames: 'morph occupiedBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemSpace methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:59:44.56'!
morph

	morph ifNil: [ morph:= S2ItemSpaceMorph new ].
	^ morph! !

!S2ItemSpace methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:38:43.9'!
morph: anObject

	morph := anObject! !

!S2ItemSpace methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:38:43.91'!
occupiedBy

	^ occupiedBy! !

!S2ItemSpace methodsFor: 'accessing' stamp: 'JB 5/13/2013 17:38:43.918'!
occupiedBy: anObject

	occupiedBy := anObject! !

Object subclass: #S2Sorter
	instanceVariableNames: 'listModel currentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

S2Sorter subclass: #S2BubbleSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:56:51.98'!
isSorted
	"Return true if the the model is sorted."

	| lastElm elm |
	self model isEmpty ifTrue: [^ true].
	lastElm := self model first.
	2 to: self model size do: 
		[:index | 
		elm := self model at: index.
		lastElm <= elm ifFalse: [^ false].
		lastElm := elm].
	^ true! !

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:43:33.746'!
nextStep
	self model size > currentPosition ifTrue:[
		self swapIfGreater: currentPosition withPosition: currentPosition + 1
		].
	currentPosition := currentPosition + 1.
	self model size == currentPosition ifTrue:[
		currentPosition := 1].
		
	^ self model.! !

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:40:02.346'!
swapIfGreater: currentPosition withPosition: nextPosition
	| item1 item2 |
	
	item1 := self model at: currentPosition.
	item2 := self model at: nextPosition.
	item1 > item2 ifTrue:[
		self model at: currentPosition put: item2.
		self model at: nextPosition put: item1.
		]! !

!S2Sorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 16:48:23.886'!
model
	 ^ listModel! !

!S2Sorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:18:45.244'!
model: aList
	listModel := aList.
	currentPosition := 1! !

!S2Sorter methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 16:44:52.09'!
nextStep
	^ self subclassResponsibility
	   ! !

TestCase subclass: #S2BubbleSortTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubbleSortTests methodsFor: 'as yet unclassified' stamp: 'db 5/13/2013 17:58:33.486'!
testStepwiseSorting
	| list sorter newList |
	"list to sort"
	list := #(3 2 4 1) asOrderedCollection.
	"initializing bubble sorter"
	sorter := S2BubbleSorter new.
	sorter model: list.
	
	self assert: sorter isSorted not.	
		
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	self assert: sorter isSorted not.	
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 4 1) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 3 1 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(2 1 3 4) asOrderedCollection.
	
	newList := sorter nextStep.
	self assert: newList equals: #(1 2 3 4) asOrderedCollection.
	self assert: sorter isSorted.
	
! !
